summaryrefslogtreecommitdiff
path: root/tests
diff options
context:
space:
mode:
authorBob Proulx <bob@proulx.com>2007-09-07 10:29:32 +0200
committerJim Meyering <jim@meyering.net>2007-09-07 10:31:14 +0200
commite70487cda746cc0800a02003c93f74621640e201 (patch)
treedc77c66f8d87c28fee12db09a7f2fdf4a7521aff /tests
parent0fb836f179d0cb2509aefcf007157e02dd0814b6 (diff)
downloadcoreutils-e70487cda746cc0800a02003c93f74621640e201.tar.xz
Add a test: demonstrate that chmod ignores a dangling symlink
* tests/chmod/thru-dangling: New test. Fails. * tests/chmod/Makefile.am (TESTS): Add thru-dangling.
Diffstat (limited to 'tests')
-rw-r--r--tests/chmod/Makefile.am1
-rwxr-xr-xtests/chmod/thru-dangling45
2 files changed, 46 insertions, 0 deletions
diff --git a/tests/chmod/Makefile.am b/tests/chmod/Makefile.am
index 1388961a6..643015fef 100644
--- a/tests/chmod/Makefile.am
+++ b/tests/chmod/Makefile.am
@@ -1,5 +1,6 @@
## Process this file with automake to produce Makefile.in -*-Makefile-*-.
TESTS = \
+ thru-dangling \
inaccessible \
c-option \
equal-x \
diff --git a/tests/chmod/thru-dangling b/tests/chmod/thru-dangling
new file mode 100755
index 000000000..d972a8abf
--- /dev/null
+++ b/tests/chmod/thru-dangling
@@ -0,0 +1,45 @@
+#!/bin/sh
+# Test for proper error and exit code of chmod on a dangling symlink.
+
+# Copyright (C) 2007 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ chmod --version
+fi
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd "$pwd" && chmod -R u+rwx $t0 && rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+
+ln -s non-existent dangle || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo "$0: failure in testing framework" 1>&2
+ (exit 1); exit 1
+fi
+
+fail=0
+
+# This operation cannot succeed since the symbolic link dangles.
+chmod 644 dangle && fail=1
+
+(exit $fail); exit $fail